#include <iostream>

using namespace std;

int main()
{
    int n; cin>>n;
    int a[n];int b[n];
    for(int i=0;i<n;i++)cin>>a[i];
    for(int i=0;i<n;i++)cin>>b[i];

    int r=a[0];
    int prefxor[n];prefxor[0]=a[0];
    for(int i=1;i<n;i++)prefxor[i]=prefxor[i-1]^a[i];
    
    
    int maxr=0;
    for(int i=0;i<n;i++)maxr=(a[i]*b[i]>maxr)?a[i]*b[i]:maxr;


    for(int i=0;i<n;i++){
          int andr=b[i];
        for(int j=i+1;j<n;j++){
            andr=andr&b[j];
            if(andr==0)break;
            int xorr;
            if(i!=0)xorr=prefxor[i-1]^prefxor[j];
            else xorr=prefxor[j];
            maxr=(xorr*andr>maxr)?xorr*andr:maxr;
        }
    }

    cout<<maxr;
    return 0;
}